diff --git a/app/addons/gift_certificates/func.php b/app/addons/gift_certificates/func.php
index 614bdfe59e8..3a255254eb1 100644
--- a/app/addons/gift_certificates/func.php
+++ b/app/addons/gift_certificates/func.php
@@ -534,6 +534,10 @@ function fn_gift_certificates_save_cart_content_post(&$cart, &$user_id, &$type,
     }
 
     if (!empty($cart['gift_certificates']) && is_array($cart['gift_certificates'])) {
+        /** @var \Tygh\Storefront\Storefront $storefront */
+        $storefront = Tygh::$app['storefront'];
+        $storefront_id = $storefront->storefront_id;
+
         $_cart_gift_cert = $cart['gift_certificates'];
         foreach ($_cart_gift_cert as $_item_id => $_gift_cert) {
             $_cart_gift_cert[$_item_id]['user_id'] = $user_id;
@@ -546,6 +550,7 @@ function fn_gift_certificates_save_cart_content_post(&$cart, &$user_id, &$type,
             $_cart_gift_cert[$_item_id]['amount'] = 1;
             $_cart_gift_cert[$_item_id]['user_type'] = empty(Tygh::$app['session']['auth']['user_id']) ? 'U' : 'R';
             $_cart_gift_cert[$_item_id]['session_id'] = Tygh::$app['session']->getID();
+            $_cart_gift_cert[$_item_id]['storefront_id'] = $storefront_id;
 
             db_query('REPLACE INTO ?:user_session_products ?e', $_cart_gift_cert[$_item_id]);
         }
@@ -579,7 +584,11 @@ function fn_gift_certificates_extract_cart(&$cart, &$user_id, &$type, &$user_typ
         $user_type
     );
 
-    if (!empty($cart['gift_certificates']) && fn_allowed_for('MULTIVENDOR')) {
+    if (
+        !empty($cart['gift_certificates'])
+        && !empty($cart['products'])
+        && fn_allowed_for('MULTIVENDOR')
+    ) {
         foreach ($cart['products'] as $cart_id => $product) {
             if (!empty($product['extra']['parent']['certificate'])) {
                 continue;
